package dk.dtu.compute.se2.videoserver;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class ReceiveVideo extends Thread {
	
	final private static int BUFFER_SIZE = 32 * 1024;
	
	private Socket socket;
	private File file;
	private VideoOutHandler videoOutHandler;

	public ReceiveVideo(Socket socket, File file, VideoOutHandler videoOutHandler) {
		super();
		assert file != null && file.canWrite();
		this.file = file;
		this.videoOutHandler = videoOutHandler;
		this.socket = socket;
	}
	
	public void run() {
		
		InputStream inputStream = null;
	    OutputStream outputStream = null;
	    
	    try {
	    	inputStream = socket.getInputStream();
	    	outputStream = new FileOutputStream(file);

	    	byte[] buffer = new byte[BUFFER_SIZE];
	    	int bytesRead;
	    	while ((bytesRead = inputStream.read(buffer)) != -1) {
	    		outputStream.write(buffer, 0, bytesRead);
	    	}
	    	
			outputStream.close();
			outputStream = null;
			
			videoOutHandler.newFile(file);
			
	    } catch (IOException e) {}
	    
	    finally {
	    	if (inputStream != null) {
	    		try {
					inputStream.close();
				} catch (IOException e) {
					System.out.println("IOException occurred");
				}
	    	}
	    	if (outputStream != null) {
	    		try {
					outputStream.close();
				} catch (IOException e) {
					System.out.println("IOException occurred");
				}
	    	}
	    }

	}
	
	

}
