package dk.dtu.compute.se2.videoserver;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Date;

public class SendVideo extends Thread {
	
	final private static int BUFFER_SIZE = 32 * 1024;
	
	private Socket socket;
	private File file;

	public SendVideo(Socket socket, File file) {
		super();
		this.socket = socket;
		this.file = file;
	}
	
	public void run() {
		
		InputStream inputStream = null;
	    OutputStream outputStream = null;
	    
	    try {
	    	socket.getInputStream().read(new byte[BUFFER_SIZE]);
	    	inputStream = new FileInputStream(file);
	    	outputStream = socket.getOutputStream(); 
	    	
			String reply =
					"HTTP/1.1 200 OK\r\n" +
					"Server: Ekkart's simple video server\r\n" +
					"Date: " + (new Date()) + "\r\n" + 
					"Content-Type: video/mp4\r\n" +
					"Content-Length: " + file.length() + "\r\n" +
					"Last-Modified: " + new Date(file.lastModified()) + "\r\n" +
					"Connection: keep-alive\r\n" +
					"Accept-Ranges: bytes\r\n"+
					"\r\n";
			
			outputStream.write(reply.getBytes());

	    	byte[] buffer = new byte[BUFFER_SIZE];
	    	int bytesRead;
	    	while ((bytesRead = inputStream.read(buffer)) != -1) {
	    		outputStream.write(buffer, 0, bytesRead);
	    	}
	    	
			outputStream.close();
			outputStream = null;
	    } catch (IOException e) {
			System.out.println("IOException occurred");
		}
	    
	    finally {
	    	if (inputStream != null) {
	    		try {
					inputStream.close();
				} catch (IOException e) {
					System.out.println("IOException occurred");
				}
	    	}
	    	if (outputStream != null) {
	    		try {
					outputStream.close();
				} catch (IOException e) {
					System.out.println("IOException occurred");
				}
	    	}
	    }

	}
	
	

}
