package dk.dtu.compute.se2.videoserver;

import java.io.File;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class VideoInHandler extends Thread {
	
	private final int VIDEO_IN_PORT = 8800;	
	
	private boolean stopped;
	
	private File folder;
	private int count;
	
	private Socket socket;
	private VideoOutHandler videoOutHandler;
	
	
	public VideoInHandler(File folder, VideoOutHandler videoOutHandler) {
		assert folder != null && folder.isDirectory();
		this.folder = folder;
		
		count = 0;
		
		stopped = false;
		this.videoOutHandler = videoOutHandler;
		socket = null;
		
	}
	
	public void run () {
		try {
			ServerSocket serverSocket = new ServerSocket(VIDEO_IN_PORT);
			
			while (!stopped) {
				socket = serverSocket.accept();

				String filename= VideoServer.VIDEO_FILE_NAME_PREFIX + 
						++count +
						"." +
						VideoServer.VIDEO_FILE_NAME_SUFFIX;
					
			    File file = new File(folder.getAbsolutePath() + "\\" + filename);
				
				if (file != null) {
					ReceiveVideo receiveVideo = new ReceiveVideo(socket, file, videoOutHandler);
					receiveVideo.start();
				}
			}
		} catch (IOException e) {
			System.out.println("IOException occurred");
		};
		
	}
	
	synchronized void abort() {
		stopped = true;
	}

}
