package dk.dtu.compute.se2.videoserver;

import java.io.File;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class VideoOutHandler extends Thread {
	
	private final int VIDEO_OUT_PORT = 8801;
	
	private boolean stopped;
	
	private File latest;
	
	public VideoOutHandler() {
		this.latest = null;
		stopped = false;
	}

	public void run() {
		ServerSocket serverSocket = null;
		try {
			serverSocket = new ServerSocket(VIDEO_OUT_PORT);
		} catch (IOException e) {
			System.out.println("IOException occurred");
			stopped = true;
			return;
		}
		
		while (!stopped) {
			Socket socket = null;
			try {
				socket = serverSocket.accept();

				if (latest != null) {
					SendVideo sendVideo = new SendVideo(socket, latest);
					sendVideo.start();
				} else {
					socket.close();
				}
			} catch (IOException e) {
				System.out.println("IOException occurred");
			};
		}
		
		try {
			serverSocket.close();
		} catch (IOException e) {
			System.out.println("IOException occurred");
		};
	}
	
	synchronized public void newFile(File file) {
		if (file != null && file.isFile() && file.canRead()) {
			latest = file;
		}
	}
	
	public void abort() {
		stopped = true;
	}

}
